#include "WidgetFactory.h"
#include "WinFactory.h"
#include "GTKFactory.h"
#include "Widget.h"


//#define __WIN  // emulate compilation under Windows

int main() {
	WidgetFactory* factory;

	// decide which factory to use at compile time. Windows compilers define the __WIN symbol
#ifdef __WIN
	factory = new WinFactory;
#else
	factory = new GTKFactory;
#endif

	Widget* button;
	Widget* window;

	button = factory->createButton();
	window = factory->createWindow();

	window->draw();
	button->draw();

	delete button;
	delete window;
	delete factory;
}
